#include <bindings.dsl.h>
#include <gts.h>

-- | <http://gts.sourceforge.net/reference/gts-vectors-and-matrices.html>

module Bindings.Gts.BasicMacrosFunctionsAndDataStructures.VectorsAndMatrices where
import Bindings.GLib
import Bindings.Gts.Types
#strict_import

#cinline gts_vector_init , <GtsVector> -> Ptr <GtsPoint> -> Ptr <GtsPoint> -> IO ()
#cinline gts_vector_scalar , <GtsVector> -> <GtsVector> -> IO <gdouble>
#cinline gts_vector_cross , <GtsVector> -> <GtsVector> -> <GtsVector> -> IO ()
#cinline gts_vector_norm , <GtsVector> -> IO <gdouble>
#cinline gts_vector_normalize , <GtsVector> -> IO ()

#ccall gts_vector_print , <GtsVector> -> Ptr CFile -> IO ()
#ccall gts_vector4_print , <GtsVector4> -> Ptr CFile -> IO ()

#ccall gts_matrix_new , <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> IO (Ptr <GtsMatrix>) 
#ccall gts_matrix_assign , Ptr <GtsMatrix> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> <gdouble> -> IO ()
#ccall gts_matrix_zero , Ptr <GtsMatrix> -> IO (Ptr <GtsMatrix>) 
#ccall gts_matrix_identity , Ptr <GtsMatrix> -> IO (Ptr <GtsMatrix>) 
#ccall gts_matrix_projection , Ptr <GtsTriangle> -> IO (Ptr <GtsMatrix>) 
#ccall gts_matrix_scale , Ptr <GtsMatrix> -> <GtsVector> -> IO (Ptr <GtsMatrix>) 
#ccall gts_matrix_translate , Ptr <GtsMatrix> -> <GtsVector> -> IO (Ptr <GtsMatrix>) 
#ccall gts_matrix_rotate , Ptr <GtsMatrix> -> <GtsVector> -> <gdouble> -> IO (Ptr <GtsMatrix>) 
#ccall gts_matrix_transpose , Ptr <GtsMatrix> -> IO (Ptr <GtsMatrix>) 
#ccall gts_matrix_determinant , Ptr <GtsMatrix> -> IO <gdouble>
#ccall gts_matrix_inverse , Ptr <GtsMatrix> -> IO (Ptr <GtsMatrix>) 
#ccall gts_matrix3_inverse , Ptr <GtsMatrix> -> IO (Ptr <GtsMatrix>) 
#ccall gts_matrix_product , Ptr <GtsMatrix> -> Ptr <GtsMatrix> -> IO (Ptr <GtsMatrix>) 
#ccall gts_matrix_compatible_row , Ptr <GtsMatrix> -> <GtsVector> -> <guint> -> <GtsVector> -> <gdouble> -> IO <guint>
#ccall gts_matrix_quadratic_optimization , Ptr <GtsMatrix> -> <GtsVector> -> <guint> -> Ptr <GtsMatrix> -> <GtsVector> -> IO <guint>
#ccall gts_matrix_print , Ptr <GtsMatrix> -> Ptr CFile -> IO ()
#ccall gts_matrix_destroy , Ptr <GtsMatrix> -> IO ()
