#include <bindings.dsl.h>
#include <gts.h>

-- | <http://gts.sourceforge.net/reference/gts-segments.html>

module Bindings.Gts.GeometricalObjectHierarchy.Segments where
import Bindings.GLib
import Bindings.Gts.Types
#strict_import

#globalvar gts_allow_floating_vertices , <gboolean>

#cinline GTS_SEGMENT_CLASS , Ptr a -> Ptr <GtsSegmentClass>
#cinline GTS_SEGMENT , Ptr a -> Ptr <GtsSegment>
#cinline GTS_IS_SEGMENT , Ptr a -> Ptr <gboolean> 

#ccall gts_segment_class , IO (Ptr <GtsSegmentClass>) 
#ccall gts_segment_new , Ptr <GtsSegmentClass> -> Ptr <GtsVertex> -> Ptr <GtsVertex> -> IO (Ptr <GtsSegment>) 

#cinline gts_segments_are_identical , Ptr <GtsSegment> -> Ptr <GtsSegment> -> IO <gboolean>

#ccall gts_segments_are_intersecting , Ptr <GtsSegment> -> Ptr <GtsSegment> -> IO <GtsIntersect>
#ccall gts_segment_is_duplicate , Ptr <GtsSegment> -> IO (Ptr <GtsSegment>) 
#ccall gts_segment_is_ok , Ptr <GtsSegment> -> IO <gboolean>

#cinline gts_segment_connect , Ptr <GtsSegment> -> Ptr <GtsVertex> -> Ptr <GtsVertex> -> IO <gboolean>
#cinline gts_segments_touch , Ptr <GtsSegment> -> Ptr <GtsSegment> -> IO <gboolean>

#ccall gts_segments_from_vertices , Ptr <GSList> -> IO (Ptr <GSList>) 
#ccall gts_segment_midvertex , Ptr <GtsSegment> -> Ptr <GtsVertexClass> -> IO (Ptr <GtsVertex>) 
