#include <bindings.dsl.h>
#include <gts.h>

-- | <http://gts.sourceforge.net/reference/gts-surfaces.html>

module Bindings.Gts.GeometricalObjectHierarchy.Surfaces where
import Bindings.GLib
import Bindings.Gts.Types
#strict_import

#cinline GTS_SURFACE_CLASS , Ptr a -> Ptr <GtsSurfaceClass>
#cinline GTS_SURFACE , Ptr a -> Ptr <GtsSurface>
#cinline GTS_IS_SURFACE , Ptr a -> Ptr <gboolean> 

#ccall gts_surface_class , IO (Ptr <GtsSurfaceClass>) 
#ccall gts_surface_new , Ptr <GtsSurfaceClass> -> Ptr <GtsFaceClass> -> Ptr <GtsEdgeClass> -> Ptr <GtsVertexClass> -> IO (Ptr <GtsSurface>) 
#ccall gts_surface_add_face , Ptr <GtsSurface> -> Ptr <GtsFace> -> IO ()
#ccall gts_surface_remove_face , Ptr <GtsSurface> -> Ptr <GtsFace> -> IO ()
#ccall gts_surface_copy , Ptr <GtsSurface> -> Ptr <GtsSurface> -> IO (Ptr <GtsSurface>) 
#ccall gts_surface_merge , Ptr <GtsSurface> -> Ptr <GtsSurface> -> IO ()
#ccall gts_surface_read , Ptr <GtsSurface> -> Ptr <GtsFile> -> IO <guint>
#ccall gts_surface_is_manifold , Ptr <GtsSurface> -> IO <gboolean>
#ccall gts_surface_is_orientable , Ptr <GtsSurface> -> IO <gboolean>
#ccall gts_surface_is_closed , Ptr <GtsSurface> -> IO <gboolean>
#ccall gts_surface_vertex_number , Ptr <GtsSurface> -> IO <guint>
#ccall gts_surface_edge_number , Ptr <GtsSurface> -> IO <guint>
#ccall gts_surface_face_number , Ptr <GtsSurface> -> IO <guint>
#ccall gts_surface_boundary , Ptr <GtsSurface> -> IO (Ptr <GSList>) 
#ccall gts_surface_area , Ptr <GtsSurface> -> IO <gdouble>
#ccall gts_surface_volume , Ptr <GtsSurface> -> IO <gdouble>
#ccall gts_surface_center_of_mass , Ptr <GtsSurface> -> <GtsVector> -> IO <gdouble>
#ccall gts_surface_center_of_area , Ptr <GtsSurface> -> <GtsVector> -> IO <gdouble>

#ccall gts_surface_stats , Ptr <GtsSurface> -> Ptr <GtsSurfaceStats> -> IO ()
#ccall gts_surface_quality_stats , Ptr <GtsSurface> -> Ptr <GtsSurfaceQualityStats> -> IO ()
#ccall gts_surface_print_stats , Ptr <GtsSurface> -> Ptr CFile -> IO ()
#ccall gts_surface_write , Ptr <GtsSurface> -> Ptr CFile -> IO ()
#ccall gts_surface_write_oogl , Ptr <GtsSurface> -> Ptr CFile -> IO ()
#ccall gts_surface_write_oogl_boundary , Ptr <GtsSurface> -> Ptr CFile -> IO ()
#ccall gts_surface_write_vtk , Ptr <GtsSurface> -> Ptr CFile -> IO ()

#ccall gts_surface_foreach_vertex , Ptr <GtsSurface> -> <GtsFunc> -> <gpointer> -> IO ()
#ccall gts_surface_foreach_edge , Ptr <GtsSurface> -> <GtsFunc> -> <gpointer> -> IO ()
#ccall gts_surface_foreach_face , Ptr <GtsSurface> -> <GtsFunc> -> <gpointer> -> IO ()
#ccall gts_surface_foreach_face_remove , Ptr <GtsSurface> -> <GtsFunc> -> <gpointer> -> IO <guint>
#ccall gts_surface_foreach_intersecting_face , Ptr <GtsSurface> -> <GtsBBTreeTraverseFunc> -> <gpointer> -> IO <gboolean>

#ccall gts_surface_traverse_new , Ptr <GtsSurface> -> Ptr <GtsFace> -> IO (Ptr <GtsSurfaceTraverse>) 
#ccall gts_surface_traverse_next , Ptr <GtsSurfaceTraverse> -> Ptr <guint> -> IO (Ptr <GtsFace>) 
#ccall gts_surface_traverse_destroy , Ptr <GtsSurfaceTraverse> -> IO ()
#ccall gts_surface_distance , Ptr <GtsSurface> -> Ptr <GtsSurface> -> <gdouble> -> Ptr <GtsRange> -> Ptr <GtsRange> -> IO ()
#ccall gts_surface_strip , Ptr <GtsSurface> -> IO (Ptr <GSList>) 
#ccall gts_surface_tessellate , Ptr <GtsSurface> -> <GtsRefineFunc> -> <gpointer> -> IO ()
#ccall gts_surface_generate_sphere , Ptr <GtsSurface> -> <guint> -> IO (Ptr <GtsSurface>) 
#ccall gts_surface_split , Ptr <GtsSurface> -> IO (Ptr <GSList>) 
