#include <bindings.dsl.h>
#include <gts.h>

-- | <http://gts.sourceforge.net/reference/gts-triangles.html>

module Bindings.Gts.GeometricalObjectHierarchy.Triangles where
import Bindings.GLib
import Bindings.Gts.Types
#strict_import

#cinline GTS_TRIANGLE_CLASS , Ptr a -> Ptr <GtsTriangleClass>
#cinline GTS_TRIANGLE , Ptr a -> Ptr <GtsTriangle>
#cinline GTS_IS_TRIANGLE , Ptr a -> Ptr <gboolean> 

#ccall gts_triangle_class , IO (Ptr <GtsTriangleClass>) 
#ccall gts_triangle_new , Ptr <GtsTriangleClass> -> Ptr <GtsEdge> -> Ptr <GtsEdge> -> Ptr <GtsEdge> -> IO (Ptr <GtsTriangle>) 
#ccall gts_triangle_set , Ptr <GtsTriangle> -> Ptr <GtsEdge> -> Ptr <GtsEdge> -> Ptr <GtsEdge> -> IO ()
#ccall gts_triangle_area , Ptr <GtsTriangle> -> IO <gdouble>
#ccall gts_triangle_perimeter , Ptr <GtsTriangle> -> IO <gdouble>
#ccall gts_triangle_quality , Ptr <GtsTriangle> -> IO <gdouble>
#ccall gts_triangle_normal , Ptr <GtsTriangle> -> Ptr <gdouble> -> Ptr <gdouble> -> Ptr <gdouble> -> IO ()
#ccall gts_triangle_revert , Ptr <GtsTriangle> -> IO ()
#ccall gts_triangle_orientation , Ptr <GtsTriangle> -> IO <gdouble>
#ccall gts_triangle_is_duplicate , Ptr <GtsTriangle> -> IO (Ptr <GtsTriangle>) 
#ccall gts_triangles_angle , Ptr <GtsTriangle> -> Ptr <GtsTriangle> -> IO <gdouble>
#ccall gts_triangles_are_compatible , Ptr <GtsTriangle> -> Ptr <GtsTriangle> -> Ptr <GtsEdge> -> IO <gboolean>
#ccall gts_triangle_enclosing , Ptr <GtsTriangleClass> -> Ptr <GSList> -> <gdouble> -> IO (Ptr <GtsTriangle>) 
#ccall gts_triangles_common_edge , Ptr <GtsTriangle> -> Ptr <GtsTriangle> -> IO (Ptr <GtsEdge>) 
#ccall gts_triangle_neighbor_number , Ptr <GtsTriangle> -> IO <guint>
#ccall gts_triangle_neighbors , Ptr <GtsTriangle> -> IO (Ptr <GSList>) 
#ccall gts_triangle_vertices_edges , Ptr <GtsTriangle> -> Ptr <GtsEdge> -> Ptr (Ptr <GtsVertex>) -> Ptr (Ptr <GtsVertex>) -> Ptr (Ptr <GtsVertex>) -> Ptr (Ptr <GtsEdge>) -> Ptr (Ptr <GtsEdge>) -> Ptr (Ptr <GtsEdge>) -> IO ()
#ccall gts_triangle_vertex_opposite , Ptr <GtsTriangle> -> Ptr <GtsEdge> -> IO (Ptr <GtsVertex>) 
#ccall gts_triangle_edge_opposite , Ptr <GtsTriangle> -> Ptr <GtsVertex> -> IO (Ptr <GtsEdge>) 
#ccall gts_triangle_vertices , Ptr <GtsTriangle> -> Ptr (Ptr <GtsVertex>) -> Ptr (Ptr <GtsVertex>) -> Ptr (Ptr <GtsVertex>) -> IO ()

#cinline gts_triangle_vertex , Ptr <GtsTriangle> -> IO (Ptr <GtsVertex>)

#ccall gts_triangle_is_ok , Ptr <GtsTriangle> -> IO <gboolean>
#ccall gts_triangle_use_edges , Ptr <GtsEdge> -> Ptr <GtsEdge> -> Ptr <GtsEdge> -> IO (Ptr <GtsTriangle>) 
#ccall gts_triangle_circumcircle_center , Ptr <GtsTriangle> -> Ptr <GtsPointClass> -> IO (Ptr <GtsPoint>) 
#ccall gts_triangle_is_stabbed , Ptr <GtsTriangle> -> Ptr <GtsPoint> -> Ptr <gdouble> -> IO (Ptr <GtsObject>) 
#ccall gts_triangles_are_folded , Ptr <GSList> -> Ptr <GtsVertex> -> Ptr <GtsVertex> -> <gdouble> -> IO <gboolean>
#ccall gts_triangles_from_edges , Ptr <GSList> -> IO (Ptr <GSList>) 
#ccall gts_triangle_interpolate_height , Ptr <GtsTriangle> -> Ptr <GtsPoint> -> IO ()
